<template>
  <div class="my-4 font-inter">
    <div class="flex items-center border-1-5 border-borderGray rounded-full p-2 w-fit pr-4 cursor-pointer"
      @click="executeAction(props.item)">
      <!-- User profile picture-->
      <ProfilePicture :profile-pic="props.item.profile_pic" />

      <!-- User name, surname and email-->
      <div>
        <div class="font-bold leading-3">{{ props.item.first_name }} {{ props.item.last_name }}</div>
        <div class="leading-normal text-email font-medium">{{ props.item.email }}</div>
      </div>
    </div>

    <!-- Nested children -->
    <ul v-if="props.item.children" class="ml-14 inner-list">
      <li v-for="childItem in props.item.children" :key="childItem.id">
        <Item :item="childItem" />
      </li>
    </ul>
  </div>
</template>

<script setup lang="ts">
import { defineProps } from 'vue';
import ItemType from '../types/ItemType';
import ProfilePicture from './ProfilePicture.vue';

const props = defineProps<{
  item: ItemType
}>()

// Executes one of the three possible actions, depending on the item id
// It calculates (id % 3) as we have 3 possible actions, but it's just
// a custom choice. It could be absolutely random, as it is not specified.
const executeAction = (item: ItemType) => {
  switch (item.id % 3) {
    case 0:
      console.log(`${item.first_name} ${item.last_name}`);
      break;
    case 1:
      window.open(`mailto:${item.email}`, '_blank');
      break;
    case 2:
      window.open(item.profile_pic, '_blank');
      break;
  }
}
</script>
